/* Copyright (C) 1991, 1992, 1993  Free Software Association of Germany

   This program is free software; you can redistribute it and/or modify
   it under the terms of the DFSL or the GNU General Public License as 
   published by the Free Software Association of Germany.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   DFSL or the GNU General Public License for more details.

   You should have received a copy of the DFSL or the GNU General 
   Public License along with this program; if not, write to the 
   Free Software Association, c/o Michaela Merz, Heimatring 19,
   6000 Frankfurt/Main 80, Germany. Or write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */



/* 	xftp.h 
	Written by Ruediger & Michaela Merz <styx||misch@eurom.rhein-mein.de> */

#ifdef	AIXV3
#include <time.h>
#endif

#if defined(SUN) || defined(linux)
#include <sys/time.h>
#endif

#ifdef	HPUX
#include <sys/stdsyms.h>
#include <sys/time.h>
#endif
	
#include <stdio.h>
#include <sys/stat.h>
#include <sys/signal.h>
#include <errno.h>
#include <netdb.h>
#include <pwd.h>
#include <sys/utsname.h>

#include <sys/types.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#if !defined(HPUX) && !defined(linux)
/* #include <sys/stream.h>*/
#include <sys/stropts.h>
#endif

#include <sys/stat.h>
#include <sys/signal.h>

#ifndef	HPUX
#include <sys/dir.h>
#endif

#ifndef	SUN
#include <dirent.h>
#endif

#include <fcntl.h>
#include <errno.h>
#include <varargs.h>
#include <errstr.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/cursorfont.h>
#include <Xm/Xm.h>
#include <Xm/Text.h>
#include <Xm/RowColumn.h>
#include <Xm/MainW.h>
#include <Xm/CascadeB.h>
#include <Xm/BulletinB.h>
#include <Xm/PushB.h>
#include <Xm/CutPaste.h>
#include <Xm/SelectioB.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Separator.h>
#include <Xm/ArrowB.h>
#include <Xm/List.h>
#include <Xm/MessageB.h>
#include <Xm/DialogS.h>
#include <Xm/ToggleB.h>
#include <Xm/Label.h>

#ifdef	XPM
#include <X11/xpm.h>
#endif

typedef	struct		_men_pt{
	char	*label;
	int		(*fnc) ();
	caddr_t	args;
}men_pt;

extern	int	get_ano_pw(char *);
extern	FILE * dataconn(char *,int );
extern	unsigned long read_asci(FILE *, int );
extern	void HandleCancel(Widget ,caddr_t , XmAnyCallbackStruct *);
extern	int quit_action(Widget , caddr_t , XmAnyCallbackStruct *);
extern	void quit(Widget , caddr_t , XmAnyCallbackStruct *);
extern	Widget MakeMenuPane( char *, Widget , men_pt *);
extern	void AttachToCascade(Widget , char *, Widget );
extern	Widget CreateForm(Widget );
extern	Widget CreateInput(Widget , char *,char *, char *,int );
extern	Widget CreateCommands(Widget );
extern	Widget create_dir_input(Widget,char *,char *,int);
extern	Widget dir_list_w(Widget,int ,int ,int ,char *);
extern	void set_cursor(Widget ,Cursor );
extern	int		con_host();
extern	char	*get_remote_file_size(char *);
extern	XtTimerCallbackProc 	act_time();
extern	char *mk_nstring(long);
extern	char 	*crf(char *);
extern	unsigned long read_view_file(FILE *, int );


#define	MAX_HOSTS	256
#define dpy XtDisplay(main_widget)
#define screen XtScreen(main_widget)
#define root    XtScreen(main_widget)->root
#define colormap XDefaultColormapOfScreen(screen)


struct	_host_list {
	char	host[512];
	char	alias[512];
	int		num;
}host_list[MAX_HOSTS];

struct sockaddr_in	tcp_srv_addr;
struct sockaddr_in	myctladdr;
struct sockaddr_in	data_addr;
struct servent		tcp_serv_info;
struct hostent		tcp_host_info;

extern	int	c_hd,d_hd;
extern	int	hv_sigint;
#define	MAX_DIR_ENTRY	1500

struct	_dir_info {
	int		files;
	int		subdirs;
	long	size;
}dir_info;

/* #define	FILES_COPY				0*/

#define	FILES_DELETE			0
#define	FILES_QUIT				1
#define	VIEWS_REMOTE_FILE		2
#define	VIEWS_LOCAL_FILE		3

/* #define	VIEWS_LOCAL_DIRECTORY	5
#define	VIEWS_LOG_SESSION		6
#define	VIEWS_HOST_INFO			7
#define	VIEWS_TRANS_STAT		8
#define	VIEWS_BATCH_SCHED 		9*/

#define	PROPS_TOOL				4

/* #define	PROPS_LOCAL_FILE 		11
#define	PROPS_REMOTE_FILE		12
#define	PROPS_SAVE_LAYOUT		13*/

#define	CONNECT_CONNECT			5
#define	CONNECT_DISCONNECT		6


extern	long	bytes_trans;		
extern	int	blk_in,blk_out;
extern	char	my_host[80];
extern	Widget	main_widget;
extern	int		trans_direction;
extern	Widget	top_level;
extern	Widget	trans_BB;
extern	Widget	main_widget;
extern	Widget	host_BB;
extern	Widget	R_List,L_List;
extern	Widget	local_label_info;
extern	Widget	menu_button[20];
extern	Widget	a_tr_size_label;
extern	Widget	b_tr_size_label;
extern	Widget	tr_status_label2;
extern	Widget	trans_ok_button;
extern	Widget	time_inf_value_label;
extern	Widget	left_host,right_host;
extern	Widget	text_win;
extern	Widget	text_widget;
extern	Widget	text_field[3];
extern	Widget	dir_input[2];
extern	Widget	props_BB;
extern	Widget	main_line[2];
extern	Widget	search_left_button,search_right_button,command_right_button;
extern	Widget	txt_command;
extern	Widget	co_bb;

extern	Widget	list_form;

static  XtAppContext    appContext;
extern	char	pw_ano[80];
extern	char	passw[80];
extern	char	FIRST_IN;
extern	char	global_error[100];
extern	char	set_show_trans_win_back;
extern	char	*tmp_file;
extern	char	connected;
extern	char	my_host[80];
extern	char	debug;
extern	char	*dbg_file;
extern	char	local_dir[2048];
extern	char	remote_dir[2048];
extern	char	local_file[2048];
extern	char	remote_file[2048];
extern	char	dir_entry_type;
extern	char	*home;
extern	char	*local_list[MAX_DIR_ENTRY],*remote_list[MAX_DIR_ENTRY];
extern	char	simple_list;
extern	char	*point_to_simple_entry;

extern	FILE	*dbg_fp;
struct 	timeval t_start, t_stop;

extern	long	bytes_trans;		
extern	long	bytes_total;

extern	int		trans_direction;
extern	int		text_pos;
extern	int		men_but_ptr;
extern	int		pw_ptr;
extern	int		hptr;
extern	int		c_hd,d_hd;
extern	int		hv_sigint;
extern	int		hv_alarm;

extern	Cursor busy_cursor;

#define	F_B	30
#define	DEFAULT_PAGER	"builtin+"
#define	DEFAULT_TMP_VIEW_FILE	"/tmp/xftp.tmp_view"
#define	DEFAULT_DEBUG_FILE	"/tmp/xftp.dbg"
#define	RC_FILE	".xftprc"

struct	tool_flags{
	char	r_unique;
	char	l_unique;
	char	conf_del;
	char	conf_over;
	char	conf_send;
	char	conf_receive;
	char	show_trans;
	char	quit_conf;
	char	save_local_dir;	
	char	viewer[1024];
	char	dbg_file[1024];
	char	start_dir[2048];
	char	view_file[1024];
}tool_f;





static XmStringCharSet  charset = (XmStringCharSet) 
								XmSTRING_DEFAULT_CHARSET;
extern	XmString	search_arr[MAX_HOSTS];
extern	XmString	list_arr[MAX_DIR_ENTRY];
