/* Copyright (C) 1991, 1992, 1993  Free Software Association of Germany

   This program is free software; you can redistribute it and/or modify
   it under the terms of the DFSL or the GNU General Public License as 
   published by the Free Software Association of Germany.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   DFSL or the GNU General Public License for more details.

   You should have received a copy of the DFSL or the GNU General 
   Public License along with this program; if not, write to the 
   Free Software Association, c/o Michaela Merz, Heimatring 19,
   6000 Frankfurt/Main 80, Germany. Or write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */



/* 	xftp_props.c 
	Written by Ruediger & Michaela Merz <styx||misch@eurom.rhein-mein.de> */
	
	
	
#include	<xftp.h>


Widget	toggle_button[9];
Widget	viewer;


XtCallbackProc props_win()
{
	static	Widget	props_dialog;
	Widget	props_form;
	Widget	title_label;
	Widget	props_sep_top,props_sep_bottom;
	Widget	save_button,cancel_button;
	Widget	toggle_title[4];
	void	r_unique();
	void	l_unique();
	void	conf_del();
	void	conf_over();
	void	conf_quit();
	void	auto_stat();
	void	auto_save_dir();
	void	cancel_props();
	void	save_props();
	void	put_f();
	void	get_f();
	int		y_pointer;
	Widget	view_label;
	Widget	sel_text;
	Widget	sel_label;
	int		i;
	char	*toggle_res[]={
			"remoteUniqe",
			"localUniqe",
			"confirmDel",
			"conirmOver",
			"autoStat",
			"putFile",
			"getFile",
			"confirmQuit",
			"autoSaveDir"
	};

	if(props_BB == (Widget) 0)
	{
		
		props_BB = XmCreatePromptDialog(top_level,
						"propsBB",NULL,0);
		
		sel_text= XmSelectionBoxGetChild(props_BB,XmDIALOG_TEXT);
		sel_label= XmSelectionBoxGetChild(props_BB,
					XmDIALOG_SELECTION_LABEL);
		XtUnmanageChild(sel_text);
		XtUnmanageChild(sel_label);

		props_form=XtVaCreateManagedWidget("propsForm",
						xmFormWidgetClass,props_BB,
						NULL);
		for(i=0;i<9;i++)
			toggle_button[i]=XtVaCreateManagedWidget(toggle_res[i],
					xmToggleButtonWidgetClass,props_form,
					NULL);
		XtVaSetValues(toggle_button[1],
				XmNleftWidget,toggle_button[0],
				XmNleftAttachment,XmATTACH_WIDGET,
				NULL);
		XtVaSetValues(toggle_button[3],
				XmNleftWidget,toggle_button[2],
				XmNleftAttachment,XmATTACH_WIDGET,
				NULL);

		view_label = XtVaCreateManagedWidget("inputViewLabel",
				xmLabelWidgetClass,props_form,
				NULL);
		viewer = XtVaCreateManagedWidget("inputView",
				xmTextWidgetClass,props_form,
				XmNmaxLength,1024,
				XmNcolumns,30,
				NULL);
		XtAddCallback(toggle_button[0],XmNvalueChangedCallback,
			(XtCallbackProc)r_unique,0);
		XtAddCallback(toggle_button[1],XmNvalueChangedCallback,
			(XtCallbackProc)l_unique,0);
		XtAddCallback(toggle_button[2],XmNvalueChangedCallback,
			(XtCallbackProc)conf_del,0);
		XtAddCallback(toggle_button[3],XmNvalueChangedCallback,
			(XtCallbackProc)conf_over,0);
		XtAddCallback(toggle_button[4],XmNvalueChangedCallback,
			(XtCallbackProc)auto_stat,0);
		XtAddCallback(toggle_button[5],XmNvalueChangedCallback,
			(XtCallbackProc)put_f,0);
		XtAddCallback(toggle_button[6],XmNvalueChangedCallback,
			(XtCallbackProc)get_f,0);
		XtAddCallback(toggle_button[7],XmNvalueChangedCallback,
			(XtCallbackProc)conf_quit,0);
		XtAddCallback(toggle_button[8],XmNvalueChangedCallback,
			(XtCallbackProc)auto_save_dir,0);

		XtAddCallback(props_BB,XmNcancelCallback,
			(XtCallbackProc)cancel_props,0);
		XtAddCallback(props_BB,XmNokCallback,
			(XtCallbackProc)save_props,0);

	}
	
	set_props();

	XtManageChild(props_BB);

}

set_props()
{
	XtVaSetValues(toggle_button[0], XmNset,tool_f.r_unique, NULL);
	XtVaSetValues(toggle_button[1], XmNset,tool_f.l_unique, NULL);
	XtVaSetValues(toggle_button[2], XmNset,tool_f.conf_del, NULL);
	XtVaSetValues(toggle_button[3], XmNset,tool_f.conf_over, NULL);
	XtVaSetValues(toggle_button[4], XmNset,tool_f.show_trans, NULL);
	XtVaSetValues(toggle_button[5], XmNset,tool_f.conf_send, NULL);
	XtVaSetValues(toggle_button[6], XmNset,tool_f.conf_receive, NULL);
	XtVaSetValues(toggle_button[7], XmNset,tool_f.quit_conf, NULL);
	XtVaSetValues(toggle_button[8], XmNset,tool_f.save_local_dir, NULL);
 	XtVaSetValues(viewer, XmNvalue,tool_f.viewer, NULL);
}


void r_unique(Widget parent,caddr_t client_data, caddr_t call_data)
{
	
	XmToggleButtonCallbackStruct *toggle_struct = 
		(XmToggleButtonCallbackStruct *) call_data;
	tool_f.r_unique=toggle_struct->set;

}

void l_unique(Widget parent,caddr_t client_data, caddr_t call_data)
{
	XmToggleButtonCallbackStruct *toggle_struct = 
		(XmToggleButtonCallbackStruct *) call_data;
	tool_f.l_unique=toggle_struct->set;
}

void conf_del(Widget parent,caddr_t client_data, caddr_t call_data)
{
	XmToggleButtonCallbackStruct *toggle_struct = 
		(XmToggleButtonCallbackStruct *) call_data;
	tool_f.conf_del=toggle_struct->set;
}

void conf_over(Widget parent,caddr_t client_data, caddr_t call_data)
{
	XmToggleButtonCallbackStruct *toggle_struct = 
		(XmToggleButtonCallbackStruct *) call_data;
	tool_f.conf_over=toggle_struct->set;
}
void put_f(Widget parent,caddr_t client_data, caddr_t call_data)
{
	XmToggleButtonCallbackStruct *toggle_struct = 
		(XmToggleButtonCallbackStruct *) call_data;
	tool_f.conf_send=toggle_struct->set;
}
void get_f(Widget parent,caddr_t client_data, caddr_t call_data)
{
	XmToggleButtonCallbackStruct *toggle_struct = 
		(XmToggleButtonCallbackStruct *) call_data;
	tool_f.conf_receive=toggle_struct->set;
}

void auto_stat(Widget parent,caddr_t client_data, caddr_t call_data)
{
	XmToggleButtonCallbackStruct *toggle_struct = 
		(XmToggleButtonCallbackStruct *) call_data;
	tool_f.show_trans=toggle_struct->set;
}
void auto_save_dir(Widget parent,caddr_t client_data, caddr_t call_data)
{
	XmToggleButtonCallbackStruct *toggle_struct = 
		(XmToggleButtonCallbackStruct *) call_data;
	tool_f.save_local_dir=toggle_struct->set;
}

void conf_quit(Widget parent,caddr_t client_data, caddr_t call_data)
{
	XmToggleButtonCallbackStruct *toggle_struct = 
		(XmToggleButtonCallbackStruct *) call_data;
	tool_f.quit_conf=toggle_struct->set;
}

void cancel_props()
{
	read_defaults();
	XtUnmanageChild(props_BB);
}

void save_props()
{
 	strcpy(tool_f.viewer,XmTextGetString(viewer));
	write_rc();
	XtUnmanageChild(props_BB);
}
